#pragma once

// C++ system level
#include <string>
#include <functional>

// project specific
#include "SpiderLib/NumberTypes.hpp"


namespace SiliconTorch {

  namespace Impl {

    class RS485 {
      public:
        RS485(u8 tx, u8 rx, u8 de, u8 re, u32 baudRate = 115200, u8 uartChannel = 1);

        u32 getBaudRate();
        void setBaudRate(u32 baudRate);

        u32 available();
        u32 read(u8* data, u32 length);

      private:

        u8 uartChannel;
        u8 tx, rx, de, re;

        void txEN(bool state);
        void rxEN(bool state);
        void txrxEN(bool state);

        // Receive only ATM!
        void write(std::string& data);
        void write(const u8* data, u32 length);

    };
  }
}
